#Regression analysis as per CEG cross submission
#First need to calculated airport betas for full sample

library(stringr)
library(Rblpapi)
library(dplyr)
library(zoo)
library(tidyr)
library(lubridate)
library(data.table)
library(plyr)

routes <- read.csv("Data/CEG_routes.csv")

textA <- "StartDate-"
textB <- "EndDate-"
text_daily <- "-Daily-Results.csv"
text_weekly <- "-Weekly-Results.csv"
text_4weekly <- "-FourWeekly-Results.csv"
text_location <- "Airport analysis/Results/"

data1 <- fread(paste(text_location,textA,"2007-10-01",textB,"2012-09-30",text_daily,sep=""))
data2 <- fread(paste(text_location,textA,"2007-10-01",textB,"2012-09-30",text_weekly,sep=""))
data3 <- fread(paste(text_location,textA,"2007-10-01",textB,"2012-09-30",text_4weekly,sep=""))

data4 <- fread(paste(text_location,textA,"2012-10-01",textB,"2017-09-30",text_daily,sep=""))
data5 <- fread(paste(text_location,textA,"2012-10-01",textB,"2017-09-30",text_weekly,sep=""))
data6 <- fread(paste(text_location,textA,"2012-10-01",textB,"2017-09-30",text_4weekly,sep=""))

data7 <- fread(paste(text_location,textA,"2017-10-01",textB,"2022-09-30",text_daily,sep=""))
data8 <- fread(paste(text_location,textA,"2017-10-01",textB,"2022-09-30",text_weekly,sep=""))
data9 <- fread(paste(text_location,textA,"2017-10-01",textB,"2022-09-30",text_4weekly,sep=""))

data10 <- fread(paste(text_location,textA,"2017-10-01",textB,"2020-02-28",text_daily,sep=""))
data11 <- fread(paste(text_location,textA,"2017-10-01",textB,"2020-02-28",text_weekly,sep=""))
data12 <- fread(paste(text_location,textA,"2017-10-01",textB,"2020-02-28",text_4weekly,sep=""))

data13 <- fread(paste(text_location,textA,"2020-03-01",textB,"2022-09-30",text_daily,sep=""))
data14 <- fread(paste(text_location,textA,"2020-03-01",textB,"2022-09-30",text_weekly,sep=""))
data15 <- fread(paste(text_location,textA,"2020-03-01",textB,"2022-09-30",text_4weekly,sep=""))

data1 <- data1[,Code,Assetbeta]
data2 <- data2[,Code,Assetbeta]
data3 <- data3[,Code,Assetbeta]
data4 <- data4[,Code,Assetbeta]
data5 <- data5[,Code,Assetbeta]
data6 <- data6[,Code,Assetbeta]
data7 <- data7[,Code,Assetbeta]
data8 <- data8[,Code,Assetbeta]
data9 <- data9[,Code,Assetbeta]
data10 <- data10[,Code,Assetbeta]
data11 <- data11[,Code,Assetbeta]
data12 <- data12[,Code,Assetbeta]
data13 <- data13[,Code,Assetbeta]
data14 <- data14[,Code,Assetbeta]
data15 <- data15[,Code,Assetbeta]

setnames(data1,"Assetbeta","Assetbeta_200712_5yr_daily")
setnames(data2,"Assetbeta","Assetbeta_200712_5yr_weekly")
setnames(data3,"Assetbeta","Assetbeta_200712_5yr_4weekly")

setnames(data4,"Assetbeta","Assetbeta_201217_5yr_daily")
setnames(data5,"Assetbeta","Assetbeta_201217_5yr_weekly")
setnames(data6,"Assetbeta","Assetbeta_201217_5yr_4weekly")

setnames(data7,"Assetbeta","Assetbeta_201722_5yr_daily")
setnames(data8,"Assetbeta","Assetbeta_201722_5yr_weekly")
setnames(data9,"Assetbeta","Assetbeta_201722_5yr_4weekly")

setnames(data10,"Assetbeta","Assetbeta_201820_2yr_daily")
setnames(data11,"Assetbeta","Assetbeta_201820_2yr_weekly")
setnames(data12,"Assetbeta","Assetbeta_201820_2yr_4weekly")

setnames(data13,"Assetbeta","Assetbeta_202022_2yr_daily")
setnames(data14,"Assetbeta","Assetbeta_202022_2yr_weekly")
setnames(data15,"Assetbeta","Assetbeta_202022_2yr_4weekly")

setkey(data1, Code)
setkey(data2, Code)
setkey(data3, Code)
setkey(data4, Code)
setkey(data5, Code)
setkey(data6, Code)
setkey(data7, Code)
setkey(data8, Code)
setkey(data9, Code)
setkey(data10, Code)
setkey(data11, Code)
setkey(data12, Code)
setkey(data13, Code)
setkey(data14, Code)
setkey(data15, Code)

data <- data1[data2,][data3,][data4,][data5,][data6,][data7,][data8,][data9,][data10,][data11,][data12,][data13,][data14,][data15,]

#Prepare data for standard regressions
data <- left_join(data,routes,by="Code")
data <- data[Routes != 0]

#Regression using CEG choice of last two five years

CEG_sample <- data[,':=' (Assetbeta = mean(c(Assetbeta_201217_5yr_weekly,Assetbeta_201217_5yr_4weekly,Assetbeta_201722_5yr_weekly,Assetbeta_201722_5yr_4weekly))), by=Code]

model <- lm(Assetbeta ~ Routes, data = CEG_sample)
summary(model)

#Regression using 2017-22 data, weekly and 4 weekly

recent_sample <- data[,':=' (Assetbeta = mean(c(Assetbeta_201722_5yr_weekly,Assetbeta_201722_5yr_4weekly))), by=Code]

model <- lm(Assetbeta ~ Routes, data = recent_sample)
summary(model)

#Regression using 2007-12 and 2012-17 data, weekly and 4 weekly

Previous_two_five_sample <- data[,':=' (Assetbeta = mean(c(Assetbeta_200712_5yr_weekly,Assetbeta_200712_5yr_4weekly,Assetbeta_201217_5yr_weekly,Assetbeta_201217_5yr_4weekly))), by=Code]

model <- lm(Assetbeta ~ Routes, data = Previous_two_five_sample)
summary(model)

#Regression using 2020-22 data, weekly and 4 weekly

Covid_sample <- data[,':=' (Assetbeta = mean(c(Assetbeta_202022_2yr_weekly,Assetbeta_202022_2yr_4weekly))), by=Code]

model <- lm(Assetbeta ~ Routes, data = Covid_sample)
summary(model)

#Regression using pre-Covid data, weekly and 4 weekly

Pre_covid_sample <- data[,':=' (Assetbeta = mean(c(Assetbeta_200712_5yr_weekly,Assetbeta_200712_5yr_4weekly,Assetbeta_201217_5yr_weekly,Assetbeta_201217_5yr_4weekly,Assetbeta_201820_2yr_weekly,Assetbeta_201820_2yr_4weekly))), by=Code]
                                         
model <- lm(Assetbeta ~ Routes, data = Pre_covid_sample)
summary(model)

#Add dummy variable for firms from less developed countries
Country <- read.csv("Data/Country_airports.csv")
dummy_sample <- left_join(recent_sample, Country, by = "Code")

Developing <- list("Vietnam","Malaysia","Thailand","Mexico","China","India")
dummy_sample$dummy <- ifelse(dummy_sample$Country %in% Developing, 1, 0)

model <- lm(Assetbeta ~ Routes + dummy, data = dummy_sample)
summary(model)


