#Regression analysis as per CEG cross submission
#First need to calculated airport betas for full sample

library(stringr)
library(Rblpapi)
library(dplyr)
library(zoo)
library(tidyr)
library(lubridate)
library(data.table)
library(plyr)

routes <- read.csv("Data/CEG_routes.csv")

textA <- "StartDate-"
textB <- "EndDate-"
text_daily <- "-Daily-Results.csv"
text_weekly <- "-Weekly-Results.csv"
text_4weekly <- "-FourWeekly-Results.csv"
text_location <- "Airport analysis/Results/"

data1 <- fread(paste(text_location,textA,"2007-10-01",textB,"2012-09-30",text_daily,sep=""))
data2 <- fread(paste(text_location,textA,"2007-10-01",textB,"2012-09-30",text_weekly,sep=""))
data3 <- fread(paste(text_location,textA,"2007-10-01",textB,"2012-09-30",text_4weekly,sep=""))

data4 <- fread(paste(text_location,textA,"2012-10-01",textB,"2017-09-30",text_daily,sep=""))
data5 <- fread(paste(text_location,textA,"2012-10-01",textB,"2017-09-30",text_weekly,sep=""))
data6 <- fread(paste(text_location,textA,"2012-10-01",textB,"2017-09-30",text_4weekly,sep=""))

data7 <- fread(paste(text_location,textA,"2017-10-01",textB,"2022-09-30",text_daily,sep=""))
data8 <- fread(paste(text_location,textA,"2017-10-01",textB,"2022-09-30",text_weekly,sep=""))
data9 <- fread(paste(text_location,textA,"2017-10-01",textB,"2022-09-30",text_4weekly,sep=""))

data10 <- fread(paste(text_location,textA,"2017-10-01",textB,"2020-02-28",text_daily,sep=""))
data11 <- fread(paste(text_location,textA,"2017-10-01",textB,"2020-02-28",text_weekly,sep=""))
data12 <- fread(paste(text_location,textA,"2017-10-01",textB,"2020-02-28",text_4weekly,sep=""))

data13 <- fread(paste(text_location,textA,"2020-03-01",textB,"2022-09-30",text_daily,sep=""))
data14 <- fread(paste(text_location,textA,"2020-03-01",textB,"2022-09-30",text_weekly,sep=""))
data15 <- fread(paste(text_location,textA,"2020-03-01",textB,"2022-09-30",text_4weekly,sep=""))

data1$EquityBeta <- data1$Assetbeta / (1 - data1$AverageGearingDV)
data2$EquityBeta <- data2$Assetbeta / (1 - data2$gearingDV)
data3$EquityBeta <- data3$Assetbeta / (1 - data3$gearingDV)
data4$EquityBeta <- data4$Assetbeta / (1 - data4$AverageGearingDV)
data5$EquityBeta <- data5$Assetbeta / (1 - data5$gearingDV)
data6$EquityBeta <- data6$Assetbeta / (1 - data6$gearingDV)
data7$EquityBeta <- data7$Assetbeta / (1 - data7$AverageGearingDV)
data8$EquityBeta <- data8$Assetbeta / (1 - data8$gearingDV)
data9$EquityBeta <- data9$Assetbeta / (1 - data9$gearingDV)
data10$EquityBeta <- data10$Assetbeta / (1 - data10$AverageGearingDV)
data11$EquityBeta <- data11$Assetbeta / (1 - data11$gearingDV)
data12$EquityBeta <- data12$Assetbeta / (1 - data12$gearingDV)
data13$EquityBeta <- data13$Assetbeta / (1 - data13$AverageGearingDV)
data14$EquityBeta <- data14$Assetbeta / (1 - data14$gearingDV)
data15$EquityBeta <- data15$Assetbeta / (1 - data15$gearingDV)
# 
data1 <- data1[,Code,EquityBeta]
data2 <- data2[,Code,EquityBeta]
data3 <- data3[,Code,EquityBeta]
data4 <- data4[,Code,EquityBeta]
data5 <- data5[,Code,EquityBeta]
data6 <- data6[,Code,EquityBeta]
data7 <- data7[,Code,EquityBeta]
data8 <- data8[,Code,EquityBeta]
data9 <- data9[,Code,EquityBeta]
data10 <- data10[,Code,EquityBeta]
data11 <- data11[,Code,EquityBeta]
data12 <- data12[,Code,EquityBeta]
data13 <- data13[,Code,EquityBeta]
data14 <- data14[,Code,EquityBeta]
data15 <- data15[,Code,EquityBeta]

setnames(data1,"EquityBeta","Equitybeta_200712_5yr_daily")
setnames(data2,"EquityBeta","Equitybeta_200712_5yr_weekly")
setnames(data3,"EquityBeta","Equitybeta_200712_5yr_4weekly")
setnames(data4,"EquityBeta","Equitybeta_201217_5yr_daily")
setnames(data5,"EquityBeta","Equitybeta_201217_5yr_weekly")
setnames(data6,"EquityBeta","Equitybeta_201217_5yr_4weekly")
setnames(data7,"EquityBeta","Equitybeta_201722_5yr_daily")
setnames(data8,"EquityBeta","Equitybeta_201722_5yr_weekly")
setnames(data9,"EquityBeta","Equitybeta_201722_5yr_4weekly")
setnames(data10,"EquityBeta","Equitybeta_201820_2yr_daily")
setnames(data11,"EquityBeta","Equitybeta_201820_2yr_weekly")
setnames(data12,"EquityBeta","Equitybeta_201820_2yr_4weekly")
setnames(data13,"EquityBeta","Equitybeta_202022_2yr_daily")
setnames(data14,"EquityBeta","Equitybeta_202022_2yr_weekly")
setnames(data15,"EquityBeta","Equitybeta_202022_2yr_4weekly")

setkey(data1, Code)
setkey(data2, Code)
setkey(data3, Code)
setkey(data4, Code)
setkey(data5, Code)
setkey(data6, Code)
setkey(data7, Code)
setkey(data8, Code)
setkey(data9, Code)
setkey(data10, Code)
setkey(data11, Code)
setkey(data12, Code)
setkey(data13, Code)
setkey(data14, Code)
setkey(data15, Code)

data <- data1[data2,][data3,][data4,][data5,][data6,][data7,][data8,][data9,][data10,][data11,][data12,][data13,][data14,][data15,]

#Prepare data for standard regressions
data <- left_join(data,routes,by="Code")
data <- data[Routes != 0]

#Regression using CEG choice of last two five years

CEG_sample <- data[,':=' (Equitybeta = mean(c(Equitybeta_201217_5yr_weekly,Equitybeta_201217_5yr_4weekly,Equitybeta_201722_5yr_weekly,Equitybeta_201722_5yr_4weekly))), by=Code]

model <- lm(Equitybeta ~ Routes, data = CEG_sample)
summary(model)

#Regression using 2017-22 data, weekly and 4 weekly

recent_sample <- data[,':=' (Equitybeta = mean(c(Equitybeta_201722_5yr_weekly,Equitybeta_201722_5yr_4weekly))), by=Code]

model <- lm(Equitybeta ~ Routes, data = recent_sample)
summary(model)

#Regression using 2007-12 and 2012-17 data, weekly and 4 weekly

Previous_two_five_sample <- data[,':=' (Equitybeta = mean(c(Equitybeta_200712_5yr_weekly,Equitybeta_200712_5yr_4weekly,Equitybeta_201217_5yr_weekly,Equitybeta_201217_5yr_4weekly))), by=Code]

model <- lm(Equitybeta ~ Routes, data = Previous_two_five_sample)
summary(model)

#Regression using pre-Covid data, weekly and 4 weekly

Pre_covid_sample <- data[,':=' (Equitybeta = mean(c(Equitybeta_200712_5yr_weekly,Equitybeta_200712_5yr_4weekly,Equitybeta_201217_5yr_weekly,Equitybeta_201217_5yr_4weekly,Equitybeta_201820_2yr_weekly,Equitybeta_201820_2yr_4weekly))), by=Code]
                                         
model <- lm(Equitybeta ~ Routes, data = Pre_covid_sample)
summary(model)

#Add dummy variable for firms from less developed countries
Country <- read.csv("Data/Country_airports.csv")
dummy_sample <- left_join(recent_sample, Country, by = "Code")

Developing <- list("Vietnam","Malaysia","Thailand","Mexico","China","India")
dummy_sample$dummy <- ifelse(dummy_sample$Country %in% Developing, 1, 0)

model <- lm(Equitybeta ~ Routes + dummy, data = dummy_sample)
summary(model)


